/*
Lgapack Version VERSION for the simulation of flow with lattice-gas automata. 
Copyright (C) 1997 D.H. Rothman and S. Zaleski. 

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
in the file GNU_General_Public_License, along with this program; 
if not, write to the Free Software Foundation, Inc., 
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

dan@segovia.mit.edu, zaleski@lmm.jussieu.fr

 Stephane Zaleski
 LMM, UPMC, Tour 66 Case 162  
 4 place Jussieu           	
 75252 PARIS Cedex 05  
 FRANCE                

 Daniel H. Rothman
 Dept of EAPS, 54-625
 MIT
 Cambridge Ma 02139
 USA
*/
#line 1 "collision_6.c"
/* 6 particle collision operator */ 

collision_6_left(a, b, c, d, e, f, g, na, nb, nc, nd, ne, nf, ng, s)  unsigned int a; unsigned int b;unsigned int c;unsigned int d; unsigned int e; unsigned int f; unsigned int g; unsigned int *na; unsigned int *nb;unsigned int *nc;unsigned int *nd; unsigned int *ne; unsigned int *nf; unsigned int *ng; unsigned int s;
{
   unsigned int t1,t2,t3,t4,t5,t6,u1,u2,u3,g1,g2,g3,del,c1,c2,c3;

/* Exclusive or is ^ */
	      t1 = a^b;
	      t2 = b^c;
	      t3 = c^d;
	      t4 = d^e;
	      t5 = e^f;
	      t6 = f^a;
	      
	      u1 = t1 & t4;
	      u2 = t2 & t5;
	      u3 = t3 & t6;
	      
/* g means pair of opposing particles */ 

	      g1 = u1 & ( b^d );
	      g2 = u2 & ( c^e );
	      g3 = u3 & ( d^f );
	      
	      del = u1 & u2 & u3;
	      
	      /* rotate left */
	      
	      c1 = del | g1 | g3 & ~g2;
	      c2 = del | g2 | g1 & ~g3;
	      c3 = del | g3 | g2 & ~g1;
	      
#ifdef SOLID_SITES
	      *na =((~s) & (c1^a)) |( s & d);
	      *nb =((~s) & (c2^b)) |( s & e);
	      *nc =((~s) & (c3^c)) |( s & f);
	      *nd =((~s) & (c1^d)) |( s & a);
	      *ne =((~s) & (c2^e)) |( s & b);
	      *nf =((~s) & (c3^f)) |( s & c);
	      *ng = g;
#else
	      *na = c1^a;
	      *nb = c2^b;
	      *nc = c3^c;
	      *nd = c1^d;
	      *ne = c2^e;
	      *nf = c3^f;
	      *ng = g; 
#endif

 
}

/* 6 particle collision operator */ 


collision_6_right(a, b, c, d, e, f, g, na, nb, nc, nd, ne, nf, ng, s)  unsigned int a; unsigned int b;unsigned int c;unsigned int d; unsigned int e; unsigned int f; unsigned int g; unsigned int *na; unsigned int *nb;unsigned int *nc;unsigned int *nd; unsigned int *ne; unsigned int *nf; unsigned int *ng; unsigned int s;
{
   unsigned int t1,t2,t3,t4,t5,t6,u1,u2,u3,g1,g2,g3,del,c1,c2,c3;

   /* Exclusive or is ^ */
   t1 = a^b;
   t2 = b^c;
   t3 = c^d;
   t4 = d^e;
   t5 = e^f;
   t6 = f^a;
	      
   u1 = t1 & t4;
   u2 = t2 & t5;
   u3 = t3 & t6;
	      
   /* g means pair of opposing particles */ 

   g1 = u1 & ( b^d );
   g2 = u2 & ( c^e );
   g3 = u3 & ( d^f );
	      
   del = u1 & u2 & u3;
	      
   /* odd time step, rotate right */
		 
   c1 = del | g3 | g1 & ~g2;
   c2 = del | g1 | g2 & ~g3;
   c3 = del | g2 | g3 & ~g1;

#ifdef SOLID_SITES
	      *na =((~s) & (c1^a)) |( s & d);
	      *nb =((~s) & (c2^b)) |( s & e);
	      *nc =((~s) & (c3^c)) |( s & f);
	      *nd =((~s) & (c1^d)) |( s & a);
	      *ne =((~s) & (c2^e)) |( s & b);
	      *nf =((~s) & (c3^f)) |( s & c);
	      *ng = g;
#else
	      *na = c1^a;
	      *nb = c2^b;
	      *nc = c3^c;
	      *nd = c1^d;
	      *ne = c2^e;
	      *nf = c3^f;
	      *ng = g; 
#endif

 
}

