/*
                    C             B
                      \        / 
                        \    /
              D   ------  G   ------  A
                        /    \
                       /      \
                    E            F
*/

/*  Beware: 7 velocity coding is different from 6 velocity coding ! */

#define A 1
#define B 2
#define C 4
#define D 8
#define E 16
#define F 32
#define G 64
#define S 128


/*  These macros are 1 if a particle exists in direction "A", "B" etc... */
#define AP(x) (x & 1)
#define BP(x) ((x >> 1) & 1)
#define CP(x) ((x >> 2) & 1)
#define DP(x) ((x >> 3) & 1)
#define EP(x) ((x >> 4) & 1)
#define FP(x) ((x >> 5) & 1)
#define GP(x) ((x >> 6) & 1)
#define SP(x)  ((x >> 7) & 1)

/* The x momentum times 2 */

#define X_MOM(x) ((int) (2*AP(x) - 2*DP(x) + BP(x) + FP(x) - EP(x) - CP(x) ))

/* The y momentum times 2/sqrt (3 ) */

#define Y_MOM(x)  ( (int)(BP(x) + CP(x) -  EP(x) - FP(x)) )


/* This calculates the number of particles at a site. */
#define  PARTSUM(x)  ((int) (AP(x) + BP(x) + CP(x) + DP(x) + EP(x) + FP(x) + GP(x)))

#define NUMBER_IN_WORD(x) ( ((x) & 1) + (((x) >> 1) & 1) + (((x) >> 2) & 1) + (((x) >> 3) & 1) + (((x) >> 4) & 1) + (((x) >> 5) & 1) + (((x) >> 6) & 1) + (((x) >> 7) & 1) + (((x) >> 8) & 1) + (((x) >> 9) & 1) + (((x) >> 10) & 1) + (((x) >> 11) & 1) + (((x) >> 12) & 1) + (((x) >> 13) & 1) + (((x) >> 14) & 1) + (((x) >> 15) & 1) + (((x) >> 16) & 1) + (((x) >> 17) & 1) + (((x) >> 18) & 1) + (((x) >> 19) & 1) + (((x) >> 20) & 1) + (((x) >> 21) & 1) + (((x) >> 22) & 1) + (((x) >> 23) & 1) + (((x) >> 24) & 1) + (((x) >> 25) & 1) + (((x) >> 26) & 1) + (((x) >> 27) & 1) + (((x) >> 28) & 1) + (((x) >> 29) & 1) + (((x) >> 30) & 1) + (((x) >> 31) & 1) )

