/*
                    C             B
                      \        / 
                        \    /
              D   ------      ------  A
                        /    \
                       /      \
                    E            F
*/

#define A 1
#define B 2
#define C 4
#define D 8
#define E 16
#define F 32
#define S 64
#define EPS 128

/* Determine if a particle is present */
#define AP(x) (x & 1)
#define BP(x) ((x >> 1) & 1)
#define CP(x) ((x >> 2) & 1)
#define DP(x) ((x >> 3) & 1)
#define EP(x) ((x >> 4) & 1)
#define FP(x) ((x >> 5) & 1)
#define SOLID(x)  ((x >> 6) & 1)

/* The x momentum times 2 */
#define X_MOM(x) ((int) (2*AP(x) - 2*DP(x) + BP(x) + FP(x) - EP(x) - CP(x) ))

/* The y momentum times 2/sqrt (3 ) */
#define Y_MOM(x)  ( (int)(BP(x) + CP(x) -  EP(x) - FP(x)) )

/* MASS */
#define PARTSUM(x)  ((int) (AP(x) + BP(x) + CP(x) + DP(x) + EP(x) + FP(x)))

