/*
Lgapack Version VERSION for the simulation of flow with lattice-gas automata. 
Copyright (C) 1997 D.H. Rothman and S. Zaleski. 

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
in the file GNU_General_Public_License, along with this program; 
if not, write to the Free Software Foundation, Inc., 
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

dan@segovia.mit.edu, zaleski@lmm.jussieu.fr

 Stephane Zaleski
 LMM, UPMC, Tour 66 Case 162  
 4 place Jussieu           	
 75252 PARIS Cedex 05  
 FRANCE                

 Daniel H. Rothman
 Dept of EAPS, 54-625
 MIT
 Cambridge Ma 02139
 USA
*/
#include <limits.h>
#include <stdlib.h>
#include <stdio.h>
#include "macros_7.h"
#define MAXTRY 800000

add_particles(latt,nz,n)
unsigned int *latt;
int n,nz;
{
/*   Adds n particles randomly to the latt without changing the momentum
*/
  int cntr,z,px,py,p;
  unsigned short int lconf;
  unsigned  long  LONG_RND;

  cntr=0;

/* LONG_MAX is defined in limits.h . LONG_RND will help pointing to a
site of the latt */ 
  LONG_RND= LONG_MAX/((unsigned long) nz) + 1;

  if(n<0)
{
  do
    {
      cntr++;
      z = ((unsigned long)random())/LONG_RND;       
      if(z>=nz)                            
	{                                          
	  printf(" bad z : %d, rand: %ld  \n",z,random());    
	  exit(1);
	}                                         
      lconf = *(latt+z);               
      if(GP(lconf)) 
	{
	  latt[z] &= ~G;
	  n++;
	}
      if(cntr> MAXTRY)
	{
         test_cons(latt,nz,&px,&py,&p); 
         printf(" could not remove %d particles after %d steps \n",-n,MAXTRY);
	 exit(1);
       }
    }
      while(n<0);
    }
   if(n>0)  
{
   do
    {
      cntr++;
      z = ((unsigned long)random())/LONG_RND;       
      if(z>=nz)                            
	{                                          
	  printf(" bad z : %d, rand: %ld  \n",z,random());      
	  exit(1);
	}                                         
      lconf = *(latt+z);               
      if((GP(lconf)) == 0) 
	{
	  latt[z] |= G;
	  n--;
	}
      if(cntr> MAXTRY)
	{
         test_cons(latt,nz,&px,&py,&p); 
         printf(" could not add %d  particles after %d steps \n",n,MAXTRY);
	 exit(1);
       }
    }
      while(n>0);
      }
}


