/*
Lgapack Version VERSION for the simulation of flow with lattice-gas automata. 
Copyright (C) 1997 D.H. Rothman and S. Zaleski. 

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
in the file GNU_General_Public_License, along with this program; 
if not, write to the Free Software Foundation, Inc., 
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

dan@segovia.mit.edu, zaleski@lmm.jussieu.fr

 Stephane Zaleski
 LMM, UPMC, Tour 66 Case 162  
 4 place Jussieu           	
 75252 PARIS Cedex 05  
 FRANCE                

 Daniel H. Rothman
 Dept of EAPS, 54-625
 MIT
 Cambridge Ma 02139
 USA
*/
#line 1 "init_hexagon_fhp7.c"
/* 
  $Author: zaleski $
  $Revision$ 
*/
#include "macros_gen.h"
#include "macros_7.h"
#include <stdlib.h> 
#include <stdio.h> 

/* INITIAL CONDITIONS */

init_hexagon_fhp7(latt, a, b, c, d, e, f, g, na, nb, nc, nd, ne, nf, s, nx, ny)  unsigned int *latt; unsigned int *a; unsigned int *b; unsigned int *c; unsigned int *d; unsigned int *e; unsigned int *f; unsigned int *g; unsigned int *na; unsigned int *nb; unsigned int *nc; unsigned int *nd; unsigned int *ne; unsigned int *nf; unsigned int *s; int nx; int ny;
{
  int i,j,ic,jc,k,z,nz,iword,bit_order, zlatt;
  int zword, n_words, max_x_word_coord; 
  
  nz = nx*ny;
  n_words=nz/word_length;
  max_x_word_coord=nx/word_length;
  
  for(z=0;z<nz;z++)
    {
      latt[z] = 0;
    }
  if(nx != ny) 
    {
      printf("nx != ny \n"); 
      exit(-1); 
    }

  for(i=0;i< nx;i++)
    for(j=0;j<ny;j++)
      {
	jc = j - ny/2 ; ic = i - nx/2; 
	  if( ( jc > (-nx/4)) && ( jc < (nx/4))  && (ic  > (-(nx/4)) ) && ( ic < (nx/4)) && ((ic+jc) > (-nx/4)) && ((ic+jc) < (nx/4)))
	    {
	      for(k=0; k<7; k++)
		{
		  latt[i+nx*j] |= (1 << k); 
		}
	    }
	  else
	    {
	      latt[i+nx*j] = 0; 
	    }
      }
  for(zword = 0 ; zword < n_words; zword++)
    {
      a[zword] = 0;
      b[zword] = 0;
      c[zword] = 0;
      d[zword] = 0;
      e[zword] = 0;
      f[zword] = 0;
      g[zword] = 0;
      s[zword] = 0;
      
      na[zword] = 0;
      nb[zword] = 0;
      nc[zword] = 0;
      nd[zword] = 0;
      ne[zword] = 0;
      nf[zword] = 0;
    }
  
  for(j=0;j < ny; j++)
    {
      for(i=0;i < nx; i++)
	{
	  zlatt = i + nx*j;
	  iword = i / word_length;
	  zword = iword + max_x_word_coord * j; 
	  bit_order =  word_length_minus_1 - (i - iword*word_length); 
	  if(AP(latt[zlatt]))  a[zword] |= (1 << bit_order); 
	  if(BP(latt[zlatt]))  b[zword] |= (1 << bit_order); 
	  if(CP(latt[zlatt]))  c[zword] |= (1 << bit_order); 
	  if(DP(latt[zlatt]))  d[zword] |= (1 << bit_order); 
	  if(EP(latt[zlatt]))  e[zword] |= (1 << bit_order); 
	  if(FP(latt[zlatt]))  f[zword] |= (1 << bit_order); 
	  if(GP(latt[zlatt]))  g[zword] |= (1 << bit_order); 
	  if(SP(latt[zlatt]))  s[zword] |= (1 << bit_order); 
	}
    }
  
}
