#ifndef BOLTZMANN_H
#define BOLTZMANN_H
#include "boltzmann.h"
#endif

void Collision()
/* color blind collision operator */
{
  int ix,iy,i,j,alpha,beta;
  double v[2], rho, drho, sum1, sum2;
  double Gf, N[6], N2[6],Neq[6],dN, r, b;

/* compute density and velocties */  
  for(iy=0;iy<NY;iy++)
    for(ix=0;ix<NX;ix++)
      {
	rho=v[0]=v[1]=0.0;
	r=0.0;
	b=0.0;
	for(i=0;i<6;i++)
	  {
	    r +=RED(ix,iy,i);
	    b +=BLUE(ix,iy,i);

	    N[i]=RED(ix,iy,i)+BLUE(ix,iy,i);
	    rho += N[i];
	    v[0]+= N[i]*C(i,0);
	    v[1]+= N[i]*C(i,1);
	  }
	if(rho>0)
	  {
	    v[0]/= rho;
	    v[1]/= rho;
	  }
	else
 	  {
	    v[0]=0.0;
	    v[1]=0.0;
	  }
/* computation of equilibrium distribution */
	if(!SOLID(ix,iy))
	  {
	    Gf = 2.*(6.- 2.* rho)/(6.- rho);	
	    for(i=0;i<6;i++)
	      {
		sum1=sum2=0.0;
		for(alpha=0;alpha<2;alpha++)
		  sum1 += 2*C(i,alpha)*v[alpha]; 
		for(alpha=0;alpha<2;alpha++)
		  for(beta=0;beta<2;beta++)	    
		    sum2 += Gf*Q(i,alpha,beta)*v[alpha]*v[beta]; 
		Neq[i]=rho*(1+sum1+sum2)/6.0;   
  	      }
/* just your vanilla BGK */
	    for(i=0;i<6;i++)
	      N2[i]=(1.0+LAMBDA)*N[i]-LAMBDA*Neq[i];
	  }
	else /* bounce back rule @ solid */
	  {
	    N2[0]=N[3];
	    N2[1]=N[4];
	    N2[2]=N[5];
	    N2[3]=N[0];
	    N2[4]=N[1];
	    N2[5]=N[2];
	  }
	if(rho>0.0)
	  for(i=0;i<6;i++)
	    {
	      RED(ix,iy,i)=N2[i]*r/rho;
	      BLUE(ix,iy,i)=N2[i]*b/rho; 
	    }
	/* else do nothing */
      }
}







