#ifndef BOLTZMANN_H
#include "boltzmann.h"
#endif


/*-----------------------------------------------------------*
  apply gravity g to the fluid,
  then add to N(i) the gravitons:
  t_i*rho*c_i3*g/cssq 
 *-----------------------------------------------------------*/
#ifndef BOLTZMANN_H
#define BOLTZMANN_H
#include "boltzmann.h"
#endif

void AddGravity(double *lat, double gx, double gy)
{
  int ix, iy;
  int i;

  for(ix=0;ix<NX;ix++)
    for(iy=0;iy<NY;iy++)
	{
	  if(!SOLID(ix,iy))
	    {
	      for(i=0;i<6;i++)
		{
		  lat[(ix+NX*iy)*6+i] += 2.0*density*C(i,0)*gx/6.0;  
		  lat[(ix+NX*iy)*6+i] += 2.0*density*C(i,1)*gy/6.0;  
		}
	    }
	}
}


void ForceEqual(double gx, double gy)
{
  int ix, iy;
  int i;

  for(ix=0;ix<NX;ix++)
      for(iy=0;iy<NY;iy++)
	{
	  if(SOLID(ix,iy) == 0)
	    {
	      for(i=0;i<6;i++)
		{
		  if(RED(ix,iy,i)>100*BLUE(ix,iy,i))
		    RED(ix,iy,i) += 2.0*density*(C(i,0)*gx+
					 C(i,1)*gy)/6.0;  
		  else if(BLUE(ix,iy,i)>100*RED(ix,iy,i)) 
		    BLUE(ix,iy,i) -= 2.0*density*(C(i,0)*gx+
					  C(i,1)*gy)/6.0; 

		}
	    }
	}
}


