#ifndef BOLTZMANN_H
#define BOLTZMANN_H
#include "boltzmann.h"
#endif


/*------------------------------------------------------------*
 * solid, interior : 1
 *        surface  : 2
 *------------------------------------------------------------*/
	 








void InitRock(char* s)
{
  int ix,iy;


/* plane channel with walls at y=0 and y=NY-1 */
  for(ix=0;ix<NX;ix++)
    {
      s[ix]=1;      
      s[ix+NX*(NY-1)]=1;
    }
  for(iy=0;iy<NY;iy++)
    {
      for(ix=0;ix<NX;ix++)
	fprintf(stderr,"%d ",s[ix+NX*iy]);
      fprintf(stderr,"\n");
    }
      
  
}


void SetSurface(double* pore, char *s)
/*!!! warning this routine destroys all pore data !!!*/
{
  int ix, iy, i;

  for(iy=0;iy<NY;iy++)
    for(ix=0;ix<NX;ix++)
      for(i=0;i<6;i++)
	if(s[ix+iy*NX] < 1)
	  pore[(ix+iy*NX)*6+i]=1.0;

  Stream(pore);

  for(iy=0;iy<NY;iy++)
    for(ix=0;ix<NX;ix++)
      for(i=0;i<6;i++)
	if(pore[(ix+iy*NX)*6+i] > 0.0 && s[ix+iy*NX] == 1)  
	  s[ix+iy*NX] = 2;
}

  

