#ifndef BOLTZMANN_H
#include "boltzmann.h"
#endif

/*--------------------------------------------------------------*
 *
 *--------------------------------------------------------------*/
void SetUniverse(int nx, int ny)
{
  int i, alpha;

  NX=nx;
  NY=ny;

  if(!(red=(double *)calloc(NX*NY*6,sizeof(double))))
    {       
      fprintf(stderr,"%s:%d allocation error\n",__FILE__,__LINE__);
      exit(-1);
    }
  if(!(solid=(char *)calloc(NX*NY,sizeof(char))))
    {
      fprintf(stderr,"%s:%d allocation error\n",__FILE__,__LINE__);
      exit(-1);
    }
  if(!(temp=(double *)calloc(NX*NY*6,sizeof(double))))
    {       
      fprintf(stderr,"%s:%d allocation error\n",__FILE__,__LINE__);
      exit(-1);
    } 
  if(!(blue=(double *)calloc(NX*NY*6,sizeof(double))))
    {       
      fprintf(stderr,"%s:%d allocation error\n",__FILE__,__LINE__);
      exit(-1);
    } 

  Model(); 
}

void CleanUniverse()
{
  if(red)
    free(red);
  if(blue)
    free(blue);
  if(solid)
    free(solid);
  if(temp)
    free(temp); 
}  



void Model()
{ 
  int i, j, alpha, beta;

  C(0,0)= 1;   C(0,1)=0;
  C(1,0)= 0.5; C(1,1)=sqrt(3.)/2.0;
  C(2,0)=-0.5; C(2,1)=sqrt(3.)/2.0;
  C(3,0)=-1;   C(3,1)=0;
  C(4,0)=-0.5; C(4,1)=-sqrt(3.)/2.0;
  C(5,0)= 0.5; C(5,1)=-sqrt(3.)/2.0;
  
  for(i=0;i<6;i++)
    {
      for(alpha=0;alpha<2;alpha++)
	{
	  for(beta=0;beta<2;beta++)
	    {
	      Q(i,alpha,beta)=C(i,alpha)*C(i,beta)-
		0.5*DELTA(alpha,beta);
	    }
	}
    }
}
