#ifndef BOLTZMANN_H
#define BOLTZMANN_H
#include "boltzmann.h"
#endif


void TestCons(void)
{
  int ix, iy;
  int i, alpha, beta;
  double dim,mass, rho;
  double v[2], u[2], N, r, b;

  mass=0.0;
  r=b=0.0;
  v[0]=v[1]=0.0;

  for(ix=0;ix<NX;ix++)
    for(iy=0;iy<NY;iy++)
        {
	  u[0]=u[1]=0.0;
	  for(rho=0.0,i=0;i<6;i++)
	    {
	      r += RED(ix,iy,i);
	      b += BLUE(ix,iy,i);
	      N=RED(ix,iy,i)+BLUE(ix,iy,i);
	      rho += N;
	      for(alpha=0;alpha<2;alpha++)
		u[alpha] += C(i,alpha)*N;
	    }
	  mass += rho;
	  for(beta=0;beta<2;beta++)
	    {
	      if(rho>0.0)
		u[beta] /= rho;
	      v[beta] += u[beta];
	    }
	  /*	  printf("%d %f %f\n",iy,u[0],u[1]);*/
        }
  dim=(double) (NX)*(NY);
  fprintf(stderr,
	  "total m=%7.5f red=%7.5f blue=%7.5f vx=%7.5g vy=%7.5g\n",
          mass, r,b, v[0]/dim, v[1]/dim);
}






