#ifndef BOLTZMANN_H
#define BOLTZMANN_H
#include "boltzmann.h"
#endif

void WriteVel(char* szOut)
{
  int ix,iy,i;
  char szVel[128];
  int alpha;  
  double tmass;
  double tpx;
  double tpy;
  double v[3];
  FILE *fPtrOut;

  sprintf(szVel,"%s.vel",szOut);
  fprintf(stderr, "saving velocity field in file: %s\n",szVel);
  if(!(fPtrOut=fopen(szVel,"w")))
    {
      fprintf(stderr,"%s:%d cannot open file %s\n",__FILE__,
	      __LINE__, szVel);
    }
  fwrite((char *) &NX, sizeof(int), 1, fPtrOut);
  fwrite((char *) &NY, sizeof(int), 1, fPtrOut);
  for(iy=0;iy<NY;iy++)
    for(ix=0;ix<NX;ix++)
      {
	tmass= 0;
	v[0]=v[1]=0.0;
	for(i=0;i<6;i++)
	  {
	    tmass += RED(ix,iy,i);
	    v[0] += RED(ix,iy,i)*C(i,0);
	    v[1] += RED(ix,iy,i)*C(i,1);
	  }
	if(tmass == 0)
	  v[0]=v[1]=0.0;
	else
	  {
	    v[0] /= tmass;
	    v[1] /= tmass;
	  }
	fwrite((char *) v, sizeof(double), 2, fPtrOut);
      }
  fclose(fPtrOut);
}
