/* a useful numerical constant */
#define PI 3.1415927

/* Numerical particle codes */
#define EMPTY   0
#define RED     1
#define BLUE    2

/* color code for mixed red/blue output */
#define MIXED   3


/* General format for integer code of a site configuration

        Bit precedence:
        gGfFeEdDcCbBaA

        where xX is the two bit configuration EMPTY, RED, or BLUE.
*/

/* These are bitmasks for the various fields of a site configuration */
#define A_MASK 0x0003
#define B_MASK 0x000c
#define C_MASK 0x0030
#define D_MASK 0x00c0
#define E_MASK 0x0300
#define F_MASK 0x0c00
#define G_MASK 0x3000

#define N_LCONF_CODES (1024*16) /* This is the number of lconf codes.
				 * An lconf code is a 14-bit configuration */

#define N_CONF 2187             /* number of unique site configurations (3^7) */

#define N_CONF_CLASSES 360	/* This is the number of conf_classes.
				 * A conf_class is the set of configs
				 * having the same values for:
				 * #red, #blue, x_momentum, y_momentum.*/

#define N_VEL 7			/* number of velocities; 7 for FHP */

#define PX_RANGE 9              /* these numbers arise from the lattice setup */
#define PY_RANGE 5              /* described in macros.h.                     */
#define X_FIELD_RANGE 113	/* Color densities can range over 15 values   */
#define Y_FIELD_RANGE 57	/* at a site; thus the 4 neighbors that       */
				/* at a site; thus the 4 neighbors that       */
				/* contribute to the x-color field yield a    */
				/* range of 57.  The y range is greater       */
			        /* because 6 neighbors contribute to the sum, */
				/* two of them weighted with a factor of 2.   */

#define N_FIELD_CODES (X_FIELD_RANGE*Y_FIELD_RANGE)
				/* color field can be represented
				 * by any combination of x-color and
				 * and y-color within the 57*113 possible
				 * x,y color range values.	 */

#define N_ANGLES 36		/* The angles range from 0 to N_ANGLES - 1 */

#define N_ANGLE_CODES (N_ANGLES+1) 
				/*Includes the possibility of a zero field */

#define ZERO_FIELD (N_ANGLES)	/* Flag to signify zero external color field */

#define MAX_CLASS_SIZE 35	/* maximum size of a class.
				 * is also equal max number of equally possible
  				 * post-collision states.		
				 * = 7!/(4!3!)		*/

#define TIE_LIST_SIZE 34653	/* size of tie_list_data, precomputed */

