/*
Lgapack Version VERSION for the simulation of flow with lattice-gas automata. 
Copyright (C) 1997 D.H. Rothman and S. Zaleski. 

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
in the file GNU_General_Public_License, along with this program; 
if not, write to the Free Software Foundation, Inc., 
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

dan@segovia.mit.edu, zaleski@lmm.jussieu.fr

 Stephane Zaleski
 LMM, UPMC, Tour 66 Case 162  
 4 place Jussieu           	
 75252 PARIS Cedex 05  
 FRANCE                

 Daniel H. Rothman
 Dept of EAPS, 54-625
 MIT
 Cambridge Ma 02139
 USA
*/
#include "include_ilg.h"

init_lat(lattice,density,red_prob,nz)
unsigned short *lattice;
float density,red_prob;
int nz;
{
  int iz,k,particle,red;

  for (iz=0; iz<nz; iz++)
  {
    /* first insure that all sites are empty */
    lattice[iz] = ENCODE_LCONF(EMPTY,EMPTY,EMPTY,EMPTY,EMPTY,EMPTY,EMPTY);

    /* initialize with random mixture of chosen density and red conc. */
    for (k=0; k<N_VEL; k++)
    {
      particle = (int) ( (float) random()/((float) LONG_MAX + 1.) + density );
      if (particle)
      {
        red = (int) ( (float) random()/((float) LONG_MAX + 1.)+ red_prob );
        if (red)
          lattice[iz] |= (RED  << (2*k));
        else
          lattice[iz] |= (BLUE << (2*k));
      }
    }
  }
}







