/*
Lgapack Version VERSION for the simulation of flow with lattice-gas automata. 
Copyright (C) 1997 D.H. Rothman and S. Zaleski. 

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
in the file GNU_General_Public_License, along with this program; 
if not, write to the Free Software Foundation, Inc., 
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

dan@segovia.mit.edu, zaleski@lmm.jussieu.fr

 Stephane Zaleski
 LMM, UPMC, Tour 66 Case 162  
 4 place Jussieu           	
 75252 PARIS Cedex 05  
 FRANCE                

 Daniel H. Rothman
 Dept of EAPS, 54-625
 MIT
 Cambridge Ma 02139
 USA
*/
#include "include_ilg.h"

output_lat(lattice,lat_out,colorsum,nz)
unsigned short *lattice;
char *lat_out,colorsum[N_LCONF_CODES];
int nz;
{
  int iz,nred,nparticles;

  for (iz=0; iz<nz; iz++)
  {
    nparticles = PARTSUM( lattice[iz] );
    nred = REDSUM( lattice[iz] );
    if (nparticles>0)
    {
      /* all red */
      if (nred==nparticles)
        lat_out[iz] = RED;

      /* all blue */
      else if (nred==0)
        lat_out[iz] = BLUE;

      /* mixed */
      else
        lat_out[iz] = MIXED;
    }

    /* empty */
    else
      lat_out[iz] = EMPTY;
  }
}
