/*
Lgapack Version VERSION for the simulation of flow with lattice-gas automata. 
Copyright (C) 1997 D.H. Rothman and S. Zaleski. 

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
in the file GNU_General_Public_License, along with this program; 
if not, write to the Free Software Foundation, Inc., 
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

dan@segovia.mit.edu, zaleski@lmm.jussieu.fr

 Stephane Zaleski
 LMM, UPMC, Tour 66 Case 162  
 4 place Jussieu           	
 75252 PARIS Cedex 05  
 FRANCE                

 Daniel H. Rothman
 Dept of EAPS, 54-625
 MIT
 Cambridge Ma 02139
 USA
*/
#include "include_ilg.h"

test_cons(lattice,nz)
unsigned short *lattice;
int nz;
{
  int iz,nred,nblue,xmom,ymom,nparticles,lconf;

  nred = nblue = xmom = ymom = nparticles = 0;
  for (iz=0; iz<nz; iz++)
  {
    lconf = lattice[iz];
    nred += REDSUM(lconf);
    nparticles += PARTSUM(lconf);
    xmom += X_MOM(lconf);
    ymom += Y_MOM(lconf);
  }
  nblue = nparticles - nred;
  fprintf(stderr,"nred=%d, nblue=%d, xmom=%d, ymom=%d\n",nred,nblue,xmom,ymom);
}
