 
/*====================== include files =====================================*/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

/*============================= macros =====================================*/
#define BOOL int
#define TRUE  1
#define FALSE 0

#define dij(x,y) (((x)==(y)) ? 1 : 0) 
#define max(a,b) (((a) > (b)) ! (a) : (b))
#define min(a,b) (((a) < (b)) ! (a) : (b))

#define LATDIM               (Nx)*(Ny)*(Nz)
#define SOLID(ix,iy,iz)      solid[((iz)*Ny+(iy))*Nx+(ix)]
#define N(ix,iy,iz,j)        n[(((iz)*Ny+(iy))*Nx+(ix))*19+(j)]
#define UX(ix, iy, iz)       ux[((iz)*Ny+(iy))*Nx+(ix)]
#define UY(ix, iy, iz)       uy[((iz)*Ny+(iy))*Nx+(ix)]
#define UZ(ix, iy, iz)       uz[((iz)*Ny+(iy))*Nx+(ix)]

#define C(i,alpha)      c[(alpha)+3*(i)]
#define Q(i,alpha,beta) q[(i)*3*3+(alpha)*3+(beta)]

#define BOOL int
#define TRUE 1
#define FALSE 0

#ifndef PI
#define PI 3.1415927
#endif
/*=============================== globals ===================================*/

char*  solid;
float* n, *temp_lat;
float* delta;
int*   map;

float q[19*3*3];
int c[19*3];

/* input parameters */
char szOut[128];
char szSolidPath[128];
char szSolid[128];
float density;
float gravity;
float lambda_D;
float lambda_Nu;
float k;

long seed;
int Nx;
int Ny;
int Nz;



/*===========================prototypes======================================*/
void SetUniverse(int nx, int ny, int nz);
void CleanUniverse(void);
void SetD3Q19(void);

float ran1(long* idum);
void InitLat(float density, 
	     float fluctuation);

void Propagate(float* lat);
void InitPropagate(void);
void Periodic(int* temp_map);

void Relaxate(void);

void AddGravity(float density, float g);

void TestCons(void);

void WriteVel(char* szOut, char mode);











