#ifndef BGK_H 
#define BGK_H
#include "bgk.h"
#endif


void InitLat(float density, 
	     float fluctuation)
{
/* ---------------------------------------* 
 * initialize lattice
 * need to add possibility of 
 * non zero velocities
 * ---------------------------------------*/

  int i, j;
  int ix, iy, iz;
  float fRand[19];
  float total;
  float Cmax, localdensity;
  float cmsq;

  cmsq=3.0;  
  Cmax=1.0;
  total=0.0;
  

  for(iz = 0; iz < Nz; iz++)
    for(iy = 0; iy < Ny; iy++)
      for(ix = 0; ix < Nx; ix++)
	{
	  if(!SOLID(ix,iy,iz))
	    {
/* switch to options */
	      for(j=0; j<19; j++) /* assume one rest particle */
		  fRand[j]   = 1+(2.0*ran1(&seed)-1.0)*fluctuation;

	      
	      for(j =0;j<12; j++)  /* diagonals */
		  N(ix,iy,iz,j) = fRand[j]*density/36.0;
	      for(j =12;j<18; j++) /* principal axis */                      
		  N(ix,iy,iz,j) = fRand[j]*density/18.0; 

	      N(ix,iy,iz,18)=fRand[18]*density/3.0; 
	    }
	  else /* if not void space */
	    for(j=0;j<19;j++)
	      N(ix,iy,iz,j)= 0.0;

	  for(j=0;j<19;j++)
	      total  += N(ix,iy,iz,j);
	}
  fprintf(stderr,"total mass = %f\n",total);

}
   
