#ifndef BGK_H 
#define BGK_H */
#include "bgk.h"
#endif 


void SetUniverse(int nx, int ny, int nz)
{
  if(!(solid = (char* ) calloc(nx*ny*nz, sizeof(char))))
    {
       fprintf(stderr,"%s:%d allocation error\n",__FILE__,__LINE__);
       exit(-1);
     }

  if(!(n = (float* ) calloc(nx*ny*nz*19, sizeof(float))))
     {
       fprintf(stderr,"%s:%d allocation error\n",__FILE__,__LINE__);
       exit(-1);
     }
  if(!(temp_lat=(float*) calloc(Nx*Ny*Nz*19,sizeof(float))))
    {
      fprintf(stderr,"%s:%d allocation error\n",__FILE__,__LINE__);
      exit(1);
    } 

}

/*=======================================================================*/

void CleanUniverse(void)
/* cleans the mess up */
{
  if(solid != NULL)
    {
      free(solid);
      solid = NULL;
    }
  if(n != NULL)
    {
      free(n);
      n = NULL;
    }

}
/*=======================================================================*/

void SetD3Q19(void)
{
  int i, alpha, beta; 
  float cssq=1/3.0;

/* velocities w/ 4-th component zero  */  
#ifdef DIRECTIONS
    /* velocities w/ 4-th component zero  */
    { 1, 1, 0,  1, 0, 1,  0, 1, 1,
      1,-1, 0,  1, 0,-1,  0, 1,-1,
     -1,-1, 0, -1, 0,-1,  0,-1,-1,
     -1, 1, 0, -1, 0, 1,  0,-1, 1,
    /* velocties w/ 4-th component != 0  */
      1, 0, 0,  0, 1, 0,  0, 0, 1,
     -1, 0, 0,  0,-1, 0,  0, 0,-1,
    /* zero velocity of the rest particle */
      0, 0, 0};
#endif

  c[0]=1  ;c[1]=1  ;c[2]=0;
  c[3]=1  ;c[4]=0  ;c[5]=1;
  c[6]=0  ;c[7]=1  ;c[8]=1;

  c[9]=1  ;c[10]=-1;c[11]=0;
  c[12]=1 ;c[13]=0 ;c[14]=-1;
  c[15]=0 ;c[16]=1 ;c[17]=-1;

  c[18]=-1;c[19]=-1;c[20]=0;
  c[21]=-1;c[22]=0 ;c[23]=-1;
  c[24]=0 ;c[25]=-1;c[26]=-1;

  c[27]=-1;c[28]=1 ;c[29]=0;
  c[30]=-1;c[31]=0 ;c[32]=1;
  c[33]=0 ;c[34]=-1;c[35]=1;

  /* velocties w/ 4-th component != 0  */
  c[36]=1 ;c[37]=0 ;c[38]=0;
  c[39]=0 ;c[40]=1 ;c[41]=0;
  c[42]=0 ;c[43]=0 ;c[44]=1;

  c[45]=-1;c[46]=0 ;c[47]=0;
  c[48]=0 ;c[49]=-1;c[50]=0;
  c[51]=0 ;c[52]=0 ;c[53]=-1;

  /* zero velocity or rest particle */
  c[54]=0 ;c[55]=0 ;c[56]=0;

/*--------------------------------------------------------------------------*
 * compute the 3-tensor Q(i,alpha,beta), where i = 0..18, 
 * alpha, beta=0..2. By construction:
 *             Q[nSides][[a][b] = -cssq * dij[a][b]
 *--------------------------------------------------------------------------*/
  for(i = 0; i <= 18; i++)
    for(alpha = 0; alpha < 3; alpha++)
       for(beta = 0; beta < 3; beta++)
	 Q(i,alpha,beta) = C(i,alpha)*C(i,beta)-dij(alpha,beta)*cssq;
}
      

/*=======================================================================*/
