% program plotvel
% written by Olav van Genabeek 8-28-1995
% reads binary file '*'.vel


% globals
global NX NY NZ
global VX VY VZ
global SOL

%read solid
readsol
% open file	
szOut=input('file name: ','s');
fPtrOut = fopen(szOut,'r');

% read dimensions
NX = fread(fPtrOut,1,'int');         %fast
NY = fread(fPtrOut,1,'int');
NZ = fread(fPtrOut,1,'int');         %slow
%set velocities
VX(NX*NY*NZ)=0;
VY(NX*NY*NZ)=0;
VZ(NX*NY*NZ)=0;
SOLID(NX*NY*NZ)=0;

for iz=1:NZ
	for iy=1:NY
		for ix=1:NX
			VX(ix+NX*((iy-1)+NY*(iz-1)))=fread(fPtrOut,1,'float');
			VY(ix+NX*((iy-1)+NY*(iz-1)))=fread(fPtrOut,1,'float');
			VZ(ix+NX*((iy-1)+NY*(iz-1)))=fread(fPtrOut,1,'float');
			if SOL(ix+NX*((iy-1)+NY*(iz-1)))==1
				VX(ix+NX*((iy-1)+NY*(iz-1)))=0;
				VY(ix+NX*((iy-1)+NY*(iz-1)))=0;
				VZ(ix+NX*((iy-1)+NY*(iz-1)))=0;	
			end;
		end
	end
end
%stuff the velocity in to a matrix
VELZ=reshape(VZ,NX,NZ);
VELX=reshape(VX,NX,NZ);

% make an arrow plot

figure(1)
colormap([1 1 1; .5 .5 .5]);
pcolor(SOLID');
shading flat
hold on
[X,Z]=meshgrid(1:2:NX,1:2:NZ);
quiver(X,Z,VELX(1:2:NX,1:2:NZ)',VELZ(1:2:NX,1:2:NZ)',2.0,'r');
axis 'equal'
axis 'off'
hold off

figure(2)
colormap([0 0 0; .5 .5 1]);
pcolor(SOLID');
shading flat
hold on

quiver(X,Z,VELX(1:2:NX,1:2:NZ)'-mean(mean(VELX)),...
	VELZ(1:2:NX,1:2:NZ)'-mean(mean(VELZ)),2.0,'r');
axis 'equal'
axis 'off'
hold off



fclose(fPtrOut);		
			
	
