#ifndef BGK_H 
#define BGK_H
#include "bgk.h"
#endif

/*-----------------------------------------------------------*
  apply gravity g to the fluid,
  then add to N(i) the gravitons:
  t_i*rho*c_i3*g/cssq 
 *-----------------------------------------------------------*/

void AddGravity(float density, float g)
{
  int ix, iy, iz;
  int i;
  float cmsq;

  cmsq=3.0;
  for(ix=0;ix<Nx;ix++)
    for(iy=0;iy<Ny;iy++)
      for(iz=0;iz<Nz;iz++)
	{
	  if(!SOLID(ix,iy,iz))
	    {
	      for(i=0;i<12;i++)
		N(ix,iy,iz,i) += density*C(i,2)*g*cmsq/36.0; 
	      for(i=12;i<18;i++)
		N(ix,iy,iz,i) += density*C(i,2)*g*cmsq/18.0; 
	    }
	}
}

