#include <stdio.h>
#include <string.h>
#include <math.h>

#define BOOL int
#define TRUE 1
#define FALSE 0

#define CHANNEL 1
#define DISK    0
#ifdef DISK
#define XC 64                       /* pos. of disk --x cord. */
#define ZC 64                       /* pos. of disk --y cord. */
#define RADIUS  32                  /* radius of disk */   
#endif

#ifndef PI
#define PI 3.14159265
#endif

/* this is program create a solid, with 
   surfaces x = constant */

main(int argc, char* argv[])
{
  int arg;
  int i;
  int iz, iy, ix, j;
  int iR, iAngle, nAngles;
  float dR,phi;  int Nx, Ny, Nz;
  char* solid = NULL;
  int iSizeOfLattice;
  size_t charsize;
  char name[128];
  FILE* fPtrOut = NULL;

  Nx=20;
  Ny=1;
  Nz=100;
  strcpy(name,"solid");

  for (arg=1; arg<argc; arg++)
    if (!strncmp(argv[arg], "Nx", 2))
      sscanf(argv[arg], "%*[^=]%*1c%d", &Nx);
    else if (!strncmp(argv[arg], "Nz", 2))
      sscanf(argv[arg], "%*[^=]%*1c%d", &Nz);  
    else if (!strncmp(argv[arg], "file", 4))
      sscanf(argv[arg], "%*[^=]%*1c%s", name);
    else
      {
	fprintf(stderr,"The command %s is not recognized.\n", argv[i]);
	exit(1);
      }


/* Open the file for output.  */
  if (name[0] == '\0')
    {
      fprintf(stderr, "must have file name\n");
      exit(1);
    }

  iSizeOfLattice = Nx * Ny * Nz; 
  solid = (char*) calloc(iSizeOfLattice, sizeof(char));
  if(!solid)
    {
      fprintf(stderr,"%s:%d: error in allocation: %s\n",__FILE__, __LINE__, name);
      exit(1);
    }    

#if CHANNEL  
/*--------------------------------------------------------------*
 *  put solid at ix = 0 at ix = Nx  -1 
 *--------------------------------------------------------------*/
  for(iz = 0; iz < Nz; iz++)
    {
      for(iy = 0; iy < Ny; iy++)
	{
	  ix = 0;
	  *(solid+iz*Ny*Nx+iy*Nx+ix) = 1;
	  ix = Nx-1;
	  *(solid+iz*Ny*Nx+iy*Nx+ix) = 1; 
	}
    }
#endif


/*--------------------------------------------------------------*
 * write solid[]  to a binary file                                   
 *--------------------------------------------------------------*/
  if(!(fPtrOut = fopen(name, "w")) )
    {
      fprintf(stderr,"%s:%d: cannot open file: %s\n",
	      __FILE__, __LINE__, name);
      exit(1);
    }

  fwrite((char*) &Nx,sizeof(int), 1, fPtrOut);  
  fwrite((char*) &Ny,sizeof(int), 1, fPtrOut);  
  fwrite((char*) &Nz,sizeof(int), 1, fPtrOut);  
  charsize = sizeof(char);
  for(iz = 0; iz < Nz; iz++)
    for(iy = 0; iy < Ny; iy++)
      for(ix = 0; ix < Nx; ix++)
	  fwrite((char*) &solid[iz*Ny*Nx+iy*Nx+ix], 
		 charsize, 1, fPtrOut);


  close(fPtrOut);
  free(solid);
}

	
	
	
	

  

