#include <stdio.h>
#include <math.h>
#include "macros_gen.h"

/* If you use 7 velocity coding, then  
  keep this line */


#include "macros_7.h"


/* If you use 6 velocity coding, then  
 uncomment  the line  below and comment the line above */

/*
#include "macros_6.h" 
*/ 

#define NX 64
#define NY 32

#define BSZ 8
#define TBSZ 1

/* Evaporation parameters */

main()
{
  int i , j, z, nx, ny, nz, nxb,nyb,nzb,nchar;
  int iblock, jblock, tblock, t; 
  int *velx, *vely; 
  float *fvelx, *fvely, *fsol; 
  char *latt, *solid;
  FILE *infd, *outfd;

  nx = NX;
  ny = NY;
  nz = nx*ny;
  nxb = nx/BSZ;
  nyb = ny/BSZ; 
  nzb = nxb*nyb;

  latt =  (char *) malloc(nz*sizeof(char)); 
  solid =   (char * ) malloc(nz*sizeof(char)); 
  fsol = (float * )  malloc(nz*sizeof(float)); 
  velx =  (int *)  malloc(nzb*sizeof(int));
  vely =  (int *)  malloc(nzb*sizeof(int));
  fvelx =  (float *)  malloc(nzb*sizeof(float));
  fvely =  (float *)  malloc(nzb*sizeof(float));

  if ((infd = fopen("dumpfile","r")) == NULL)
    {
      fprintf(stderr,"Could not open file -- dumpfile --. \n");
      exit(1); 
    }

  if ((outfd = fopen("floatfile","w")) == NULL)
    {
      fprintf(stderr,"Could not open file -- floatfile --. \n");
      exit(1); 
    }
#ifndef SOLID
  {
    FILE *solidfd;
    solidfd = fopen("solid","r");
    fread((char *) solid, sizeof(char), nz*sizeof(char),solidfd);
  }
#endif
    
  t=0;
  while(0<1)
    {
      for(iblock=0; iblock < nxb; iblock++)
	for(jblock=0; jblock < nyb; jblock++)
	  {
	    velx[iblock+ nxb*jblock] = 0;
	    vely[iblock+ nxb*jblock] = 0;
	    solid[iblock+ nxb*jblock] = 1;
	  }	  
      for(tblock=0; tblock< TBSZ; tblock++) 
	{
	  nchar=fread((char *) latt, sizeof(char), nz*sizeof(char),infd); 
	  if(nchar < nz) 
	    {
	      printf("end of file at t %d\n" ,t); 
	      return 0;
	    }
	  t++;
	  for(iblock=0; iblock < nxb; iblock++)
	    for(jblock=0; jblock < nyb; jblock++)
	      {
		for(i=BSZ*iblock; i < BSZ*(iblock+1) ; i++)
		  for(j=BSZ*jblock; j < BSZ*(jblock+1) ; j++)
		    {
#ifdef SOLID
		      solid[i+nx*j]  = SOLID(latt[i+nx*j]);
#endif
		      velx[iblock+ nxb*jblock] += X_MOM(latt[i+nx*j]);
		      vely[iblock+ nxb*jblock] += Y_MOM(latt[i+nx*j]);
		    }
	      }
	}
      printf("record %d read\n",t); 

      for(iblock=0; iblock < nxb; iblock++)
	for(jblock=0; jblock < nyb; jblock++)
	  {
	    fvelx[iblock+ nxb*jblock] = ((float) velx[iblock+ nxb*jblock])/(2.*BSZ*BSZ*TBSZ);
	    fvely[iblock+ nxb*jblock] = sqrt(3.)*((float)vely[iblock+ nxb*jblock])/(2.*BSZ*BSZ*TBSZ);
	    fsol[iblock+ nxb*jblock] = ((float) solid[iblock+ nxb*jblock]);

	  }

/*      fwrite((float *) fvelx, sizeof(float), nzb*sizeof(float),outfd);
      fwrite((float *) fvely, sizeof(float), nzb*sizeof(float),outfd);
*/
/* Fortran convention*/
/*
  Write data about solid sites 
*/


      if(t==1)
	{
	  for(j=0; j < ny; j++)
	    for(i=0; i < nx; i++)
	      {
		fprintf(outfd,"%.0f \n",(float) (solid[i+ nx*j]));
/*		printf("i %d j %d %.0f \n",i,j,(float) (solid[i+ nx*j])); */
	      }
	}
/*
  Write velocity data
*/

      for(jblock=0; jblock < nyb; jblock++)
	for(iblock=0; iblock < nxb; iblock++)
	  {
	    fprintf(outfd,"%f \n",fvelx[iblock+ nxb*jblock]);
	  }
      for(jblock=0; jblock < nyb; jblock++)
	for(iblock=0; iblock < nxb; iblock++)
	  {
	    fprintf(outfd,"%f \n",fvely[iblock+ nxb*jblock]);
	  }
    }
  return 0;
}





