Pro readsum, nexp, nrep, maxmach
;
;
;


if n_params(0) lt 2 then begin
 print , "usage : readsum ,nexp, nrep [, maxmach] "
 stop
endif

if n_params(0) lt 3 then begin
  maxmach = 0.1
endif

minmach = 0.0
maxmach = maxmach*maxmach

nexp = nexp + 1
numes = fltarr(nrep+1)
nubar = fltarr(nexp)
nustd = fltarr(nexp)
mach = fltarr(nexp)
rho = fltarr(nrep+1)
rhoav = fltarr(nexp)
force = fltarr(nrep+1)
mach = fltarr(nrep+1)
nut = fltarr(nrep+1) 
machav = fltarr(nexp)
allrho = fltarr(nexp*(nrep+1))

openr, 1, "summary"

print, "mach,    nubar,      nut,       nustd"
n=0

for i=1,nexp do begin

for k=0, nrep do begin

readf, 1,  tmpmach, tmp, tmpnut, tmpforce, tmprho, irep
numes(k) = tmp
mach(k) = tmpmach
force(k) = tmpforce
rho(k) = tmprho
allrho(n) = tmprho
n = n+1
nut(k) = tmpnut 


;;print, force(k) 

endfor

nubar(i-1) = total(numes)/(nrep+1)
rhoav(i-1) = total(rho)/(nrep+1)
forceav    = total(force)/(nrep+1)
nuvar = (total(numes*numes)/(nrep+1) - nubar(i-1)*nubar(i-1))/nrep
nustd(i-1) = sqrt(nuvar)
machav(i-1)  = (-1) * total(mach)/(nrep+1)
nutav = total(nut)/(nrep+1)

print, machav(i-1), nubar(i-1), nutav, 2*nustd(i-1), forceav, rhoav(i-1)

endfor

set_plot,'X'

plot, machav*machav, nubar, psym=5,xrange=[minmach,maxmach],yrange=[0.074,0.090],XTITLE=' Mach square ',YTITLE=' fitted viscosity ', font=0

;; comment this out since density now exact. 
;; read, tmp
;; plot, allrho

;  Ecriture en postscript
;

set_plot,'PS'


;
;  Pour inserer dans LaTex au format epsf
;  
device,/encapsulated
;
;  Pour avoir une preview bitmap avec xfig
;  (uniquement avec eps)
;
device,/preview



!P.FONT = 0
;
; Pour avoir de belles polices 
;

device, /TIMES, FONT_SIZE=14

plot, machav*machav , nubar, psym=5,xrange=[minmach,maxmach],yrange=[0.074,0.090],XTITLE=' Mach square ',YTITLE=' fitted viscosity ', font=0

device, /close

end
