Pro viscous, rho, ny, force, p1, p2

if n_params(0) lt 3  then begin
 print , "usage : viscous, rho , ny, force, p1, p2  "
 stop
endif

if n_params(0) lt 5  then begin
 print , "p1=0 , p2=  ", (ny-1)
 p1 = 0
 p2 = ny - 1
endif

kmax=0
bmin=0.45
bmax=0.45

dens = rho/7
xmom = fltarr(ny); 
velo = fltarr(ny); 
densfile = fltarr(ny)
openr, 1, "profile"

readf, 1, xmom
readf, 1, densfile

;; xmom is true x_mom, i.e. the usual xmom macro divided by 2. 

velo = xmom/rho

I = findgen(ny)

for k=0,kmax do begin
  if kmax eq 0 then begin
    b = bmin
  endif
  if kmax gt 0 then begin
    b= bmin + (k/kmax)*(bmax-bmin)
  endif 
;;   b = 0.44
  FI  = (I - b)* (ny -1 - b - I)
  FI(0) = 0
  FI(ny-1) = 0
  u_0 = total( velo * FI ) / total(FI*FI)
  lsq = total( (u_0 * FI(1:ny-2) - velo(1:ny-2))*(u_0 * FI(1:ny-2) - velo(1:ny-2)) )

  nu_0 =  3 * force / (rho * 8 * u_0) 
  nu_0 = - nu_0
  nu_t = (1./28.)*( 1./(dens*(1.-dens)))* (1./(1- 8.*dens*(1-dens)/7.)) -1./8.
  print, "b= ",b, " nu_est =",nu_0, "  nu_t = ",nu_t, " lsq = ", lsq
 ;; print, " nu_est =",nu_0, "  nu_t = ",nu_t


umax = u_0 * FI(ny/2)
cs = sqrt(3./7.)
print, "Mach = ", umax/cs 

FI(0) = - FI(1) 
FI(ny-1) = - FI(ny-2)


;;  What follows is a trick to get these values out of the picture

velo(0) = 1e4
velo(ny-1) =  1e4

plot,  xrange=[p1,p2], u_0 *  FI 
oplot, velo(0:ny-1), psym=4

read, tmp
plot, densfile(0:ny-1)
endfor

close, 1



end
