#!/bin/sh

USAGE="Usage: $0 Program_name [nx]"
CFLAGS=-g

if [ $# -lt 1 -o $# -gt 2  ]
then
        echo "$USAGE"
	echo "where nx is an optional argument that must be a multiple of 32"
	echo "and no smaller than 64"
        exit 1
fi

if [ $# -lt 2 ]
then
	SIZEARGS=64	
fi

if [ $# -eq 2 ]
then
	SIZEARGS=$2
fi

N=$SIZEARGS

set -x
TESTDIR=`pwd`
TEST=test
cd ../$1
touch $1.c 
make $1 "PARARGS= -DNX='$N' -DNY='$N' -DTMAX=100 -DTPRINT=10 -DNOSOLID_SITES" "CFLAGS=$CFLAGS" 
make install "BINDIR='$TESTDIR'"  "CFLAGS=$CFLAGS"
#
# run
#
cd $TESTDIR
./$1 

make clean
rm -f  $1 ilgout dumpfile history 
